/* jshint browser: true, devel: true, undef: true, unused: true */
/** ATTENZIONE NON USARE COMMENTI CON SLASH */

var IDBROWSER_FAKEFRAME_SUFFIX = "#IDBROWSERFAKEIFRAME";
var IDBROWSER_MESSAGE_NEWFRAME = "NEWFRAME";

function IDBROWSER_registerVideoListeners(doc) {
  console.log('function IDBROWSER_registerVideoListeners,  doc: '+doc.URL + ' , '+doc.baseURI);
  var videos = doc.getElementsByTagName("video");
  console.log('function IDBROWSER_registerVideoListeners,  video size: ' + videos.length);

  doc.addEventListener('playing', function(e) {
    console.log('function IDBROWSER_registerVideoListeners, playng' + e.target.tagName);
    _idbrowserBridge.onMediaPlaying();

    if (e.target.tagName != 'VIDEO') {
      return;
    }

    var mediaElement = e.target;

    var mediaSrcType = IDBROWSER_getMediaElementSrcType(mediaElement);
    _idbrowserBridge.onVideoPlaying(mediaSrcType[0], mediaSrcType[1], mediaElement.duration);

  }, true);

  doc.addEventListener('pause', function(e) {
    _idbrowserBridge.onMediaPause();

    if (e.target.tagName != 'VIDEO') return;

    var mediaElement = e.target;

    var mediaSrcType = IDBROWSER_getMediaElementSrcType(mediaElement);
    _idbrowserBridge.onVideoPause(mediaSrcType[0], mediaSrcType[1]);

  }, true);
}


window.IDBROWSER_getMediaElementSrcType = function(videoElement) {

  // base da overridare con lo script custom per i vari siti
  var supportedMimeTypes = Array('video/3gpp', 'video/3gpp2', 'video/mp4',
    'video/quicktime', 'video/x-m4v', 'video/webm');

  var typeAttr = "";
  var src = getVideoSrc(videoElement);

  console.log('function IDBROWSER_getMediaElementSrcType, src: '+src);
  if (src === '') {
    var sources = videoElement.querySelectorAll('source');
    for (var j = 0; j < sources.length; j++) {
      var mimetype = sources[j].type;
      if (supportedMimeTypes.indexOf(mimetype) > -1) {
        src = sources[j].src;
        if (sources[j].type) {
          typeAttr = sources[j].type;
        }
        break;
      }
    }
  } else if (videoElement.type) {
    typeAttr = mediaElement.type;
  }
  return [src, typeAttr];
}


function IDBROWSER_isAboutBlank(docOrWindow) {
  return docOrWindow.location && docOrWindow.location.href === "about:blank";  
}

function IDBROWSER_tryGetFrameSrc(frameWindow) {
  var src = "error";
  try {
    src = frameWindow.frameElement.src;
  } catch(e) {}
  return src;
}

/**
 * Timer che prova a reinizializzare continuamente il document fino a quando non cambia per poi autocancellarsi
 */
function IDBROWSER_startIntervalForInitFrame(frameWindow, intervalId) {
  if (!IDBROWSER_frameIntervals[intervalId]) {
    IDBROWSER_frameIntervals[intervalId] = setInterval(function() {
        if (frameWindow.document === undefined) {          
          /* la window non è più valida capita su webview meno recenti */
          clearInterval(IDBROWSER_frameIntervals[intervalId]);
          IDBROWSER_frameIntervals[intervalId] = null;
        } else if (IDBROWSER_tryInitDoc(frameWindow.document, frameWindow)) {
          /* il document è cambiato ed è stato inizializzato, cancello il timer */
          clearInterval(IDBROWSER_frameIntervals[intervalId]);
          IDBROWSER_frameIntervals[intervalId] = null;
          /* reinizializzo la window dato che i listener vengono persi */           
          IDBROWSER_initFrame(frameWindow);
        }
    }, 100);
  }
}

/**
 * Prova ad inizilizzare il document della window del frame e si registra sull'unload
 * in modo da far partire un timer che prova a reinizializzare il document dato che quest'ultimo cambia
 * quando il frame naviga verso un altro indirizzo o quando non è ancora inizializzato (about:blank)
 * ATTENZIONE: anche se l'istanza della window resta la stessa listener e property vengono persi
 */
function IDBROWSER_initFrame(frameWindow) {
  /* disabilito i media source javascript in modo da evitare blob (es. youtube) */
  /*frameWindow.MediaSource = undefined;*/
  IDBROWSER_tryInitDoc(frameWindow.document, frameWindow);
  
  if (!frameWindow._idbrowserInitialized) {
    frameWindow._idbrowserInitialized = true;

    var intervalId = IDBROWSER_frameIntervalsId++;
    if (frameWindow._idbrowserPendingUnload) {    
      /* si è già verificato l'unload, capita quando l'src viene valorizzato da js
         starto subito il timer  per inizializzare il nuovo document */
      frameWindow._idbrowserPendingUnload = false;
      IDBROWSER_startIntervalForInitFrame(frameWindow, intervalId);
    }
    
    frameWindow.addEventListener("unload", function() {
        /* l'unload viene richiamato quando il frame naviga verso un altro indirizzo e anche sul primo caricamento
         in questo momento il contentDocument è ancora il vecchio avvio un timer che prova a reinizializzarlo appena cambia */
      IDBROWSER_startIntervalForInitFrame(frameWindow, intervalId);      
    });
  }  
}

function IDBROWSER_extractOrigin(src) {
   var matches = src.match(/^(https?\:\/\/[^\/?#]+)(?:[\/?#]|$)/i);
   return matches && matches[1];
}

function IDBROWSER_tryInitOrAddFakeFrame(doc, frame, isDocInit) {
  var currentOrigin = doc.location.origin;
  var frameSrcOrigin = IDBROWSER_extractOrigin(frame.src); 
  if (frameSrcOrigin) {
    if (currentOrigin == frameSrcOrigin) {
      /* l'origin è la stessa non c'è bisogno di un fake frame posso già inizializzare */
      IDBROWSER_initFrame(frame.contentWindow);       
    } else {
      /* controllo se già ho aggiunto un fake frame per la stessa origin e in caso lo creo */
      var fakeFrame = IDBROWSER_fakeFramesByOrigin[frameSrcOrigin];
      if (!fakeFrame) {
        
        fakeFrame = doc.createElement("iframe");
        fakeFrame.src = frameSrcOrigin + IDBROWSER_FAKEFRAME_SUFFIX;
        fakeFrame.style.display = "none";
        doc.body.appendChild(fakeFrame);
        IDBROWSER_fakeFramesByOrigin[frameSrcOrigin] = fakeFrame;
      } else if (!isDocInit) {
        /* notifico il fake frame di ricontrollare tutti i frame della window parent */
        if (fakeFrame.contentWindow) {
          fakeFrame.contentWindow.postMessage(IDBROWSER_MESSAGE_NEWFRAME, "*");
        }        
      } else {
      }
      /* sul primo unload del frame notifico il fake frame di ricontrollare tutti i parent frames dato che al primo caricamento del fake frame
         la window del frame potrebbe non essere inizializzata causando un securityerror anche se la origin è la stessa */
      var firstUnloadHandler = function() {
        frame.contentWindow.removeEventListener("unload", firstUnloadHandler);
        if (fakeFrame.contentWindow) {
          fakeFrame.contentWindow.postMessage(IDBROWSER_MESSAGE_NEWFRAME, "*");
        } 
      };
      frame.contentWindow.addEventListener("unload", firstUnloadHandler);
    }
  } else if (frame.src === ""){
    /* il frame non ha src e non posso capire la sua origin (probabilmente sarà cambiato da js a runtime)
       aspetto l'unload per provare a reinizializzarlo */
    var noSrcUnloadHandler = function() {
      frame.contentWindow.removeEventListener("unload", noSrcUnloadHandler);
      frame.contentWindow._idbrowserPendingUnload = true; /* per startare il timer durante IDBROWSER_initFrame */
      IDBROWSER_tryInitOrAddFakeFrame(doc, frame, false);      
    };
    frame.contentWindow.addEventListener("unload", noSrcUnloadHandler);
  }   
}

function IDBROWSER_initDocOnReady(doc) {  
  var iframeElems = doc.getElementsByTagName("iframe");
  for (var i = 0; i < iframeElems.length; i++) {
    IDBROWSER_tryInitOrAddFakeFrame(doc, iframeElems[i], true);    
  }

  /* tengo traccia dei nuovi iframe aggiunti a runtime */
  doc.addEventListener("DOMNodeInserted", function(ev) {
    IDBROWSER_onDOMNodeInserted(doc, ev);
  });
}

function IDBROWSER_onDOMNodeInserted(doc, ev) {
  var elem = ev.target;
  if (elem && elem.tagName) {
    if (elem.tagName.toLowerCase() == "iframe") {
      if (!elem.src.endsWith(IDBROWSER_FAKEFRAME_SUFFIX)) {
        IDBROWSER_tryInitOrAddFakeFrame(doc, elem, false);
      }
    } else {
      var iframeElems = elem.getElementsByTagName("iframe");
      for (var i = 0; i < iframeElems.length; i++) {
        IDBROWSER_tryInitOrAddFakeFrame(doc, iframeElems[i], true);    
      }
    }
  }
}

function IDBROWSER_tryInitParentFrames() {  
  if (!window.parent) return;
  if (!window.parent.frames) return;

  var frames = window.parent.frames;
  for (var i = 0; i < frames.length; i++) {
    try {
      if (frames[i] != window) {
        IDBROWSER_initFrame(frames[i]); 
      }
    } catch(e) {
    }
  }
}

function IDBROWSER_initFakeFrame() {
  IDBROWSER_tryInitParentFrames();
  window.addEventListener("message", function(event) {
    if (event.data == IDBROWSER_MESSAGE_NEWFRAME) {
      IDBROWSER_tryInitParentFrames();
    }
  });
}

/**
 * Prova ad inizilizzare un document se non è già stato inizilizzato e se non è un about:blank (quest'ultimo capita quando la window non è ancora carica)
 * Ritorna true se si è verificato un cambiamento e il documento risulta inizializzato, altrimenti false
 */
function IDBROWSER_tryInitDoc(doc, docWindow) {
  if (IDBROWSER_isAboutBlank(doc) || doc._idbrowserDocInitialized) {
    /* skippo l'inizializzazione */
    var isLocationChanged = doc._idbrowserInitLocation != doc.location;
    if (doc._idbrowserDocInitialized) {
       doc._idbrowserInitLocation = doc.location;
    }
    /* se il documento è già inizializzato e la location è cambiata ritorno true per indicare che c'è stato un cambiamento */
    return isLocationChanged && doc._idbrowserDocInitialized;
  }
  if (!doc.location) return true;
  doc._idbrowserDocInitialized = true;
  doc._idbrowserInitLocation = doc.location;

  IDBROWSER_registerVideoListeners(doc);

  if (IDBROWSER_isDocReady(doc)) {
    IDBROWSER_initDocOnReady(doc);
  } else {
    var readyStateChangeListener = function() {
      if (IDBROWSER_isDocReady(doc)) {
        doc.removeEventListener("readystatechange", readyStateChangeListener);
        IDBROWSER_initDocOnReady(this);
      }
    };
    doc.addEventListener("readystatechange", readyStateChangeListener);
  }

  return true;
}

function getVideoSrc(videoElement) {
    if("function" === typeof videojs)
    return "function" === typeof videojs ? videojs(videoElement).currentSrc() : videoElement.currentSrc;
    else if("object" === typeof mejs)
    return "object" === typeof mejs ? mejs.MediaElementPlayer(videoElement,"").options.mediaUri[0].url : videoElement.currentSrc;
    else
    return videoElement.currentSrc;
}

function IDBROWSER_isDocReady(doc) {
  return doc.readyState == "interactive" || doc.readyState == "complete";
}

if (!String.prototype.endsWith) {
  Object.defineProperty(String.prototype, 'endsWith', {
    value: function(searchString, position) {
      var subjectString = this.toString();
      if (position === undefined || position > subjectString.length) {
        position = subjectString.length;
      }
      position -= searchString.length;
      var lastIndex = subjectString.indexOf(searchString, position);
      return lastIndex !== -1 && lastIndex === position;
    }
  });
}

/* disabilito i media source javascript in modo da evitare blob (es. youtube) */
/*

MediaSource = undefined;
WebKitMediaSource = undefined;
*/


if (!window._idbrowserInjected) {
  window._idbrowserInjected = true;
  var IDBROWSER_frameIntervals = [];
  var IDBROWSER_frameIntervalsId = 0;
  var IDBROWSER_fakeFramesByOrigin = [];

  if (location.href.endsWith(IDBROWSER_FAKEFRAME_SUFFIX)) {
    IDBROWSER_initFakeFrame();
  } else {
    IDBROWSER_tryInitDoc(document, window);    
  }
} else {
}
